{$I+,B-}
program PatchWinProcs;

{  As is the case with all patch programs, you should back up all of the
   target files prior to applying the patch.  This includes TPW.TPL and
   WINPROCS.TPU.

   This program is used to patch the file WINPROCS.TPU that ships with
   either TPW 1.0 or TPW 1.5.  In the shipping version of WINPROCS, the
   HiByte and LoByte inline procedures each contain an error.  The first
   byte in each inline is $5A which is the machine code for POP DX.  This
   patch changes the first byte to $58 which is the machine code for POP
   AX.

   To use this patch, you must first extract and remove the WINPROCS unit
   from your TPW.TPL file.  Using TPUMOVER from the DOS command line, the
   syntax would be:

         >TPUMOVER TPW.TPL *WINPROCS
         >TPUMOVER TPW.TPL -WINPROCS

   Once WINPROCS has been extracted and removed, place this source in the
   same directory as WINPROCS.TPU, compile it and run it.  WINPROCS can
   then be added back to TPW.TPL with TPUMOVER using the following DOS
   command line syntax:

         >TPUMOVER TPW.TPL +WINPROCS

   This patch program can be compiled with either the DOS version or the
   Windows version of TP (ie: TP6 or TPW).  If you run this patch program
   via the Windows IDE (ie: TPW.EXE), you may need to terminate and then
   restart the IDE  after patching WINPROCS for the change to be effective
   from within the IDE (there may be an "in-memory" copy of the old version
   of WINPROCS present).

   Pat Ritchey, CIS:[70007,4660]
}


{$IFDEF WINDOWS}
uses Wincrt;
{$ENDIF}

var
  f : file;
  b : array[$7414..$743F] of byte;

Function Patch(idx : integer; OldVal,NewVal : byte) : boolean;
begin
  Patch := false;
  if b[idx] = OldVal then
     begin
     b[idx] := NewVal;
     Patch := true;
     end
  else if b[idx] = NewVal then
     Writeln('WINPROCS has already been patched')
  else
     Writeln('Can''t patch this version of WINPROCS');
end;

begin
  {$I-}
  Assign(f,'WINPROCS.TPU');
  Reset(f,1);
  {$I+}
  if IOResult <> 0 then
     begin
     Writeln('Unable to open WINPROCS.TPU');
     halt;
     end;
  Seek(f,$7414);
  BlockRead(f,b,Sizeof(b));
  if Patch($7414,$5A,$58) and Patch($743F,$5A,$58) then
     begin
     Seek(f,$7414);
     BlockWrite(f,b,sizeof(b));
     Writeln('WinProcs patched');
     end;
  Close(f);
end.

